#pragma once

#include <istream>
#include <string>
#include <memory>
#include <vector>

class ClientAccess {
	ClientAccess();
public:
	ClientAccess(const std::string& token, uint16_t port);
	static std::shared_ptr<ClientAccess> find();

public:
	std::string getBasicAuth() const;
	uint16_t getPort() const;

	std::string getURL() const;

private:

	std::string authcode;
	uint16_t port = 0;
};

std::shared_ptr<ClientAccess> createFromLockfile(std::istream& lockfile);
