#pragma once

#include <memory>

#include <QWidget>

#include "config.h"

namespace Ui {
	class RuneManager;
}

class ClientAPI;
class QListWidgetItem;

class RuneManager : public QWidget {
	Q_OBJECT

public:
	explicit RuneManager(QWidget* parent = nullptr);
	~RuneManager();

	void setConfig(Config& config);

private slots:
	void loadRunes();
	void setRunesEnabled(bool enabled);

	void clientRunePageRenamed(QListWidgetItem* item);

	void saveRunePageAA(int id, QString name, const RunePage& rp);

private:
	Ui::RuneManager* ui;
	std::shared_ptr<ClientAPI> client;
	Config* config = nullptr;
};
